﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using System.Windows;
using DynamicColors.Interfaces;

namespace DynamicColors
{
    public partial class App : Application, IApplication
    {
        private readonly Dictionary<Uri, ResourceDictionary> resources_;

        public App()
        {
            System.Windows.Forms.Application.EnableVisualStyles();
            resources_ = new Dictionary<Uri, ResourceDictionary>();
        }

        public void MergeDictionary(string path)
        { MergeDictionary(path, Assembly.GetCallingAssembly()); }

        private void MergeDictionary(string path, Assembly assembly)
        {
            var uri = string.Format(
                "pack://application:,,,/{0};component/{1}",
                assembly.GetName().Name,
                path
            );

            MergeDictionary(new Uri(uri));
        }

        private void MergeDictionary(Uri uri)
        {
            var previous_dictionary = resources_.SingleOrDefault(k => k.Key == uri).Value;

            if (previous_dictionary != null)
            {
                resources_.Remove(uri);
                Resources.MergedDictionaries.Remove(previous_dictionary);
            }

            var resource_dictionary = new ResourceDictionary() { Source = uri };
            
            resources_.Add(uri, resource_dictionary);
            Resources.MergedDictionaries.Add(resource_dictionary);
        }
    }
}
