﻿using System;
using System.Windows.Markup;
using System.Windows.Media;
using DynamicColors.Utilities;

namespace DynamicColors.MarkupExtensions
{
    public class StaticBrush : StaticExtension
    {
        public StaticBrush(string member, double modifyBy)
        {
            Member = member;
            ModifyBy = modifyBy / 100.0;
        }

        public double ModifyBy
        { get; set; }

        public override object ProvideValue(IServiceProvider serviceProvider)
        {
            if (ModifyBy == 0.0)
            {
                return new SolidColorBrush(
                    (Color) base.ProvideValue(serviceProvider)
                );
            }

            var hsl = new HslColor(
                (Color)base.ProvideValue(serviceProvider)
            );

            hsl.Luminance += ModifyBy;

            if (hsl.Luminance < 0.0)
                hsl.Luminance = 0.0;
            else if (hsl.Luminance > 1.0)
                hsl.Luminance = 1.0;
            
            return new SolidColorBrush(hsl.Color);
        }
    }
}
