﻿using System.Windows.Forms;
using System.Windows.Media;
using DynamicColors.Interfaces;
using DynamicColors.Models;
using Microsoft.Practices.Composite.Presentation.Commands;

namespace DynamicColors.ViewModels
{
    public class BaseColorsViewModel
    {
        public BaseColorsViewModel()
        {
            ChooseColor = new DelegateCommand<object>(ChooseColorExecute);
        }

        public DelegateCommand<object> ChooseColor
        { get; private set; }

        private void ChooseColorExecute(object parameter)
        {
            var dialog = new ColorDialog();
            
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                BaseColors.ButtonColor = Color.FromRgb(
                    dialog.Color.R,
                    dialog.Color.G,
                    dialog.Color.B
                );

                var app = (IApplication)System.Windows.Application.Current;
                app.MergeDictionary("Resources/Button.xaml");
            }
        }
    }
}
